<?php

namespace App\Http\Controllers;

use Illuminate\Support\Facades\View;
use Symfony\Bundle\FrameworkBundle\Controller\AbstractController;
use Symfony\Component\HttpFoundation\Request;
use Symfony\Component\HttpFoundation\Response;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Schema;
use App\Article;
use DateTime;

class ArticleController extends Controller
{
    private function convDate($data_italiana)
    {
        return DateTime::createFromFormat('Y-m-d', $data_italiana)->format('Y-d-m');
    }
    private function articoliByDataStart($data_start)
    {
        $data_start = $this->convDate($data_start);
        $data_start = $data_start . ' 00:00:00';
        ini_set("memory_limit", "512M");
        try {
            $articoli = Article::join(DB::raw('(SELECT IdArticolo, MAX(DataOra) AS data FROM T_WEB_Articoli GROUP BY IdArticolo) b'), function ($join) {
                $join->on('T_WEB_Articoli.IdArticolo', '=', 'b.IdArticolo')
                    ->on('T_WEB_Articoli.DataOra', '=', 'b.data');
            })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, SUM(Qta) as totVen, MAX(DataOra) as ultimaDataOra FROM T_WEB_Ordini WHERE DataOra > \'' . $data_start . '\' GROUP BY CodArticoloGM) O'), 'T_WEB_Articoli.IdArticolo', '=', 'O.CodArticoloGM')
                // ->leftJoin(DB::raw('(SELECT CodArticolo, SUM(Qta) as totVen, MAX(DataOra) as ultimaDataOra FROM T_WEB_ArticoliFatturati WHERE DataOra > \'' . $data_start . '\' GROUP BY CodArticolo) O'), 'T_WEB_Articoli.IdArticolo', '=', 'O.CodArticolo')
                ->leftJoin(DB::raw('(SELECT g.IdTipologia, g.Descrizione as DescrizioneTipologia FROM T_WEB_Tipologie g JOIN (SELECT IdTipologia, MAX(DataOra) as data1 from T_WEB_Tipologie GROUP BY IdTipologia) h ON g.IdTipologia = h.IdTipologia AND g.DataOra = h.data1 ) i'), function ($join) {
                    $join->on('T_WEB_Articoli.IdTipologia', '=', 'i.IdTipologia');
                })
                ->select('T_WEB_Articoli.*', 'ultimaDataOra', DB::raw('COALESCE(O.totVen, 0) as totVen'))
                ->where('totVen', '>', 0)
                ->where('DescrizioneTipologia', 'Libri')
                ->orderBy('totVen', 'desc')
                ->get();

            // var_dump($articoli->toArray());

            if ($articoli->isEmpty()) {
                return ['error' => 'Nessun articolo'];
            }

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return ['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()];
        }

        return $articoli;

    }
    private function queryOrdini($numrec)
    {
        ini_set("memory_limit", "512M");
        try {
            $ordini = DB::table('T_WEB_Ordini as O')
                ->leftJoin(DB::raw('(
                SELECT
                    IdArticolo,
                    MAX(DataOra) as data
                FROM T_WEB_Articoli
                GROUP BY IdArticolo
            ) b'), 'O.CodArticoloGM', '=', 'b.IdArticolo')
                ->join('T_WEB_Articoli as A', function ($join) {
                    $join->on('O.CodArticoloGM', '=', 'A.IdArticolo')
                        ->on('b.data', '=', 'A.DataOra');
                })
                ->select(
                    DB::raw('ROW_NUMBER() OVER (ORDER BY O.DataOra DESC) AS progressivo'),
                    'O.DataOra',
                    'O.Qta',
                    'A.Titolo',
                    'O.CodArticoloGM',
                    'A.Ean13'
                )
                ->orderBy('O.DataOra', 'desc')
                ->take($numrec)
                ->get();

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return response()->json(['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()], 500);
        }

        return $ordini;

    }
    private function queryOrdiniByIdArticolo($idArticolo)
    {
        ini_set("memory_limit", "512M");
        try {
            $ordini = DB::table('T_WEB_Ordini as O')
                ->leftJoin(DB::raw('(
                SELECT
                    IdArticolo,
                    MAX(DataOra) as data
                FROM T_WEB_Articoli
                GROUP BY IdArticolo
            ) b'), 'O.CodArticoloGM', '=', 'b.IdArticolo')
                ->join('T_WEB_Articoli as A', function ($join) {
                    $join->on('O.CodArticoloGM', '=', 'A.IdArticolo')
                        ->on('b.data', '=', 'A.DataOra');
                })
                ->select(
                    DB::raw('ROW_NUMBER() OVER (ORDER BY O.DataOra DESC) AS progressivo'),
                    'O.DataOra',
                    'O.Qta',
                    'A.Titolo',
                    'O.CodArticoloGM',
                    'A.Ean13'
                )
                ->orderBy('O.DataOra', 'desc')
                ->where('O.CodArticoloGM', '=', $idArticolo)
                ->get();

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return response()->json(['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()], 500);
        }

        return $ordini;

    }
    private function queryFatturatiByIdArticolo($idArticolo)
    {
        ini_set("memory_limit", "512M");
        try {
            $ordini = DB::table('T_WEB_ArticoliFatturati as O')
                ->leftJoin(DB::raw('(
                SELECT
                    IdArticolo,
                    MAX(DataOra) as data
                FROM T_WEB_Articoli
                GROUP BY IdArticolo
            ) b'), 'O.CodArticolo', '=', 'b.IdArticolo')
                ->join('T_WEB_Articoli as A', function ($join) {
                    $join->on('O.CodArticolo', '=', 'A.IdArticolo')
                        ->on('b.data', '=', 'A.DataOra');
                })
                ->select(
                    DB::raw('ROW_NUMBER() OVER (ORDER BY O.DataOra DESC) AS progressivo'),
                    'O.DataOra',
                    'O.Qta',
                    'A.Titolo',
                    'O.CodArticolo',
                    'A.Ean13'
                )
                ->orderBy('O.DataOra', 'desc')
                ->where('O.CodArticolo', '=', $idArticolo)
                ->get();

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return response()->json(['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()], 500);
        }

        return $ordini;

    }
    private function queryshowInfoArticolo($idArticolo)
    {
        try {
            ini_set("memory_limit", "512M");

            $articoli = Article::where('IdArticolo', $idArticolo)
                ->get(); // Usa

            if ($articoli->isEmpty()) {
                return ['error' => 'Nessun articolo'];
            }

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return ['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()];
        }

        return $articoli;
    }
    private function queryArticlesSales()
    {
        try {
            ini_set("memory_limit", "512M");

            $articoliVenduti = Article::join(DB::raw('(SELECT IdArticolo, MAX(DataOra) AS data FROM T_WEB_Articoli GROUP BY IdArticolo) b'), function ($join) {
                $join->on('T_WEB_Articoli.IdArticolo', '=', 'b.IdArticolo')
                    ->on('T_WEB_Articoli.DataOra', '=', 'b.data');
            })
                ->leftJoin(DB::raw('(SELECT e.IdStatoProdotto, e.Descrizione as DescrizioneStatoProdotto FROM T_WEB_StatiProdotto e JOIN (SELECT IdStatoProdotto, MAX(DataOra) as data1 from T_WEB_StatiProdotto GROUP BY IdStatoProdotto) c ON e.IdStatoProdotto = c.IdStatoProdotto AND e.DataOra = c.data1 ) f'), function ($join) {
                    $join->on('T_WEB_Articoli.IdStatoProdotto', '=', 'f.IdStatoProdotto');
                })
                ->leftJoin(DB::raw('(SELECT g.IdTipologia, g.Descrizione as DescrizioneTipologia FROM T_WEB_Tipologie g JOIN (SELECT IdTipologia, MAX(DataOra) as data1 from T_WEB_Tipologie GROUP BY IdTipologia) h ON g.IdTipologia = h.IdTipologia AND g.DataOra = h.data1 ) i'), function ($join) {
                    $join->on('T_WEB_Articoli.IdTipologia', '=', 'i.IdTipologia');
                })
                ->leftJoin(DB::raw('(SELECT l.IdTipoFormato, l.Descrizione as DescrizioneFormato FROM T_WEB_TipiFormato l JOIN (SELECT IdTipoFormato, MAX(DataOra) as data1 from T_WEB_TipiFormato GROUP BY IdTipoFormato) m ON l.IdTipoFormato = m.IdTipoFormato AND l.DataOra = m.data1 ) n'), function ($join) {
                    $join->on('T_WEB_Articoli.IdTipoFormato', '=', 'n.IdTipoFormato');
                })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, SUM(Qta) as totVen FROM T_WEB_Ordini GROUP BY CodArticoloGM) o'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'o.CodArticoloGM');
                })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, SUM(Qta) as venduti3mesi, RANK() OVER (ORDER BY SUM(Qta) DESC) as rank3M
                        FROM T_WEB_Ordini
                        WHERE DataOra >= DATEADD(MONTH, -3, GETDATE())
                        GROUP BY CodArticoloGM) p'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'p.CodArticoloGM');
                })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, SUM(Qta) as venduti6mesi, RANK() OVER (ORDER BY SUM(Qta) DESC) as rank6M
                        FROM T_WEB_Ordini
                        WHERE DataOra >= DATEADD(MONTH, -6, GETDATE())
                        GROUP BY CodArticoloGM) q'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'q.CodArticoloGM');
                })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, SUM(Qta) as venduti1anno, RANK() OVER (ORDER BY SUM(Qta) DESC) as rank1Y
                        FROM T_WEB_Ordini
                        WHERE DataOra >= DATEADD(MONTH, -12, GETDATE())
                        GROUP BY CodArticoloGM) r'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'r.CodArticoloGM');
                })
                ->leftJoin(DB::raw('(SELECT CodArticoloGM, MAX(DataOra) as ultimoOrdine
                        FROM T_WEB_Ordini
                        GROUP BY CodArticoloGM) s'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 's.CodArticoloGM');
                })
                ->leftJoin(DB::raw('(SELECT CodArticolo, SUM(TRY_CAST(Qta AS INT)) as fat3mesi, RANK() OVER (ORDER BY SUM(TRY_CAST(Qta AS INT)) DESC) as fatrank3M
                        FROM T_WEB_ArticoliFatturati
                        WHERE DataOra >= DATEADD(MONTH, -3, GETDATE())
                        GROUP BY CodArticolo) t'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 't.CodArticolo');
                })
                ->leftJoin(DB::raw('(SELECT CodArticolo, SUM(TRY_CAST(Qta AS INT)) as fat6mesi, RANK() OVER (ORDER BY SUM(TRY_CAST(Qta AS INT)) DESC) as fatrank6M
                        FROM T_WEB_ArticoliFatturati
                        WHERE DataOra >= DATEADD(MONTH, -6, GETDATE())
                        GROUP BY CodArticolo) t2'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 't2.CodArticolo');
                })
                ->leftJoin(DB::raw('(SELECT CodArticolo, SUM(TRY_CAST(Qta AS BIGINT)) as totFat
                    FROM T_WEB_ArticoliFatturati
                    WHERE TRY_CAST(Qta AS BIGINT) IS NOT NULL
                    GROUP BY CodArticolo) u'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'u.CodArticolo');
                })
                ->leftJoin(DB::raw('(
                    SELECT v.IdCollana, v.Descrizione as DescrizioneCollana
                    FROM T_WEB_Collane v
                    INNER JOIN (
                        SELECT IdCollana, MAX(ID) as MaxID
                        FROM T_WEB_Collane
                        GROUP BY IdCollana
                    ) x ON v.IdCollana = x.IdCollana AND v.ID = x.MaxID
                ) y'), function ($join) {
                    $join->on('T_WEB_Articoli.IdCollana', '=', 'y.IdCollana');
                })
                ->leftJoin(DB::raw('(
                    SELECT g2.IdArgomento, g2.Descrizione as DescrArgomento
                    FROM T_WEB_Argomenti g2
                    JOIN (SELECT IdArgomento, MAX(DataOra) as data12 from T_WEB_Argomenti
                    GROUP BY IdArgomento) h2
                        ON g2.IdArgomento = h2.IdArgomento AND g2.DataOra = h2.data12 ) i2'
                ), function ($join) {
                    $join->on('T_WEB_Articoli.ListaArgomenti', '=', 'i2.IdArgomento');
                })


                ->select(
                    'T_WEB_Articoli.*'
                    ,
                    'f.DescrizioneStatoProdotto',
                    'i.DescrizioneTipologia',
                    'n.DescrizioneFormato',
                    'y.DescrizioneCollana',
                    'i2.DescrArgomento',
                    DB::raw('COALESCE(o.totVen, 0) as totVen'),
                    DB::raw('COALESCE(u.totFat, 0) as totFat'),
                    DB::raw('COALESCE(p.venduti3mesi, 0) as venduti3mesi'),
                    DB::raw('COALESCE(t.fat3mesi, 0) as fat3mesi'),
                    DB::raw('COALESCE(t2.fat6mesi, 0) as fat6mesi'),
                    DB::raw('COALESCE(p.rank3M, 0) as rank3M'),
                    DB::raw('COALESCE(t.fatrank3M, 0) as fatrank3M'),
                    DB::raw('COALESCE(t2.fatrank6M, 0) as fatrank6M'),
                    DB::raw('COALESCE(q.venduti6mesi, 0) as venduti6mesi'),
                    DB::raw('COALESCE(q.rank6M, 0) as rank6M'),
                    DB::raw('COALESCE(r.venduti1anno, 0) as venduti1anno'),
                    DB::raw('COALESCE(r.rank1Y, 0) as rank1Y'),
                    DB::raw('s.ultimoOrdine')
                )
                ->where(function ($query) {
                    $query->where('DescrizioneStatoProdotto', 'In commercio')
                        ->orWhere('DescrizioneStatoProdotto', '2023 in commercio')
                        ->orWhere('DescrizioneStatoProdotto', 'Vendita sito')
                        ->orWhere('DescrizioneStatoProdotto', 'In prevendita')
                        ->orWhere('DescrizioneStatoProdotto', 'Prossima uscita');
                })
                ->where('DescrizioneTipologia', 'Libri')
                ->orderBy('totVen', 'desc')
                ->get();



            if ($articoliVenduti->isEmpty()) {
                return response()->json(['message' => 'Nessun articolo trovato.'], 404);
            }

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return response()->json(['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()], 500);
        }

        // Restituisci una risposta JSON con i dati
        return $articoliVenduti;

    }
    private function queryArticlesFatturati()
    {
        try {
            ini_set("memory_limit", "512M");

            $articoliVenduti = Article::join(DB::raw('(SELECT IdArticolo, MAX(DataOra) AS data FROM T_WEB_Articoli GROUP BY IdArticolo) b'), function ($join) {
                $join->on('T_WEB_Articoli.IdArticolo', '=', 'b.IdArticolo')
                    ->on('T_WEB_Articoli.DataOra', '=', 'b.data');
            })
                ->leftJoin(DB::raw('(SELECT e.IdStatoProdotto, e.Descrizione as DescrizioneStatoProdotto FROM T_WEB_StatiProdotto e
                                JOIN (SELECT IdStatoProdotto, MAX(DataOra) as data1
                                      FROM T_WEB_StatiProdotto GROUP BY IdStatoProdotto) c
                                ON e.IdStatoProdotto = c.IdStatoProdotto AND e.DataOra = c.data1) f'), function ($join) {
                    $join->on('T_WEB_Articoli.IdStatoProdotto', '=', 'f.IdStatoProdotto');
                })
                ->leftJoin(DB::raw('(SELECT g.IdTipologia, g.Descrizione as DescrizioneTipologia FROM T_WEB_Tipologie g
                                JOIN (SELECT IdTipologia, MAX(DataOra) as data1
                                      FROM T_WEB_Tipologie GROUP BY IdTipologia) h
                                ON g.IdTipologia = h.IdTipologia AND g.DataOra = h.data1) i'), function ($join) {
                    $join->on('T_WEB_Articoli.IdTipologia', '=', 'i.IdTipologia');
                })
                ->leftJoin(DB::raw('(SELECT l.IdTipoFormato, l.Descrizione as DescrizioneFormato FROM T_WEB_TipiFormato l
                                JOIN (SELECT IdTipoFormato, MAX(DataOra) as data1
                                      FROM T_WEB_TipiFormato GROUP BY IdTipoFormato) m
                                ON l.IdTipoFormato = m.IdTipoFormato AND l.DataOra = m.data1) n'), function ($join) {
                    $join->on('T_WEB_Articoli.IdTipoFormato', '=', 'n.IdTipoFormato');
                })
                ->leftJoin(DB::raw('(SELECT CodArticolo, SUM(TRY_CAST(Qta AS INT)) AS totFat FROM T_WEB_ArticoliFatturati
                                GROUP BY CodArticolo) o'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'o.CodArticolo');
                })
                ->leftJoin(DB::raw('(SELECT CodArticolo, SUM(TRY_CAST(Qta AS INT)) as venduti3mesi,
                                RANK() OVER (ORDER BY SUM(TRY_CAST(Qta AS INT)) DESC) as rank3M
                                FROM T_WEB_ArticoliFatturati
                                WHERE DataOra >= DATEADD(MONTH, -3, GETDATE())
                                GROUP BY CodArticolo) p'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'p.CodArticolo');
                })
                ->leftJoin(DB::raw('(SELECT CodArticolo, SUM(TRY_CAST(Qta AS INT)) as venduti6mesi,
                                RANK() OVER (ORDER BY SUM(TRY_CAST(Qta AS INT)) DESC) as rank6M
                                FROM T_WEB_ArticoliFatturati
                                WHERE DataOra >= DATEADD(MONTH, -6, GETDATE())
                                GROUP BY CodArticolo) q'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'q.CodArticolo');
                })
                ->leftJoin(DB::raw('(SELECT CodArticolo, SUM(TRY_CAST(Qta AS INT)) as venduti1anno,
                                RANK() OVER (ORDER BY SUM(TRY_CAST(Qta AS INT)) DESC) as rank1Y
                                FROM T_WEB_ArticoliFatturati
                                WHERE DataOra >= DATEADD(MONTH, -12, GETDATE())
                                GROUP BY CodArticolo) r'), function ($join) {
                    $join->on('T_WEB_Articoli.IdArticolo', '=', 'r.CodArticolo');
                })
                ->addSelect(DB::raw('(
                        SELECT MAX(DataOra)
                        FROM T_WEB_ArticoliFatturati
                        WHERE ISNUMERIC(Qta) = 1
                        AND CodArticolo = T_WEB_Articoli.IdArticolo
                    ) as ultimoOrdine'))
                ->leftJoin(DB::raw('(SELECT v.IdCollana, v.Descrizione as DescrizioneCollana
                                FROM T_WEB_Collane v
                                INNER JOIN (SELECT IdCollana, MAX(ID) as MaxID
                                            FROM T_WEB_Collane GROUP BY IdCollana) x
                                ON v.IdCollana = x.IdCollana AND v.ID = x.MaxID) y'), function ($join) {
                    $join->on('T_WEB_Articoli.IdCollana', '=', 'y.IdCollana');
                })
                ->leftJoin(DB::raw('(SELECT g2.IdArgomento, g2.Descrizione as DescrArgomento
                                FROM T_WEB_Argomenti g2
                                JOIN (SELECT IdArgomento, MAX(DataOra) as data12
                                      FROM T_WEB_Argomenti
                                      GROUP BY IdArgomento) h
                                ON g2.IdArgomento = h.IdArgomento AND g2.DataOra = h.data12) i2'), function ($join) {
                    $join->on('T_WEB_Articoli.ListaArgomenti', '=', 'i2.IdArgomento');
                })
                ->select(
                    'T_WEB_Articoli.*',
                    'f.DescrizioneStatoProdotto',
                    'i.DescrizioneTipologia',
                    'n.DescrizioneFormato',
                    'y.DescrizioneCollana',
                    'i2.DescrArgomento',
                    DB::raw('COALESCE(o.totFat, 0) as totFat'),
                    DB::raw('COALESCE(p.venduti3mesi, 0) as venduti3mesi'),
                    DB::raw('COALESCE(p.rank3M, 0) as rank3M'),
                    DB::raw('COALESCE(q.venduti6mesi, 0) as venduti6mesi'),
                    DB::raw('COALESCE(q.rank6M, 0) as rank6M'),
                    DB::raw('COALESCE(r.venduti1anno, 0) as venduti1anno'),
                    DB::raw('COALESCE(r.rank1Y, 0) as rank1Y'),
                    DB::raw('s.ultimoOrdine')
                )
                ->where(function ($query) {
                    $query->where('DescrizioneStatoProdotto', 'In commercio')
                        ->orWhere('DescrizioneStatoProdotto', '2023 in commercio')
                        ->orWhere('DescrizioneStatoProdotto', 'Vendita sito')
                        ->orWhere('DescrizioneStatoProdotto', 'In prevendita')
                        ->orWhere('DescrizioneStatoProdotto', 'Prossima uscita');
                })
                ->where('DescrizioneTipologia', 'Libri')
                //->orderBy('rank1Y', 'asc')
                ->orderBy('totFat', 'desc')
                ->get();

            if ($articoliVenduti->isEmpty()) {
                return response()->json(['message' => 'Nessun articolo fatturato trovato.'], 404);
            }

        } catch (\Exception $e) {
            // Registrazione dell'errore
            return response()->json(['error' => 'Si è verificato un errore durante il recupero dei dati: ' . $e->getMessage()], 500);
        }

        return $articoliVenduti;

    }

    public function showArticlesSales(Request $request)
    {
        try {

            $articoliVenduti = $this->queryArticlesSales();

            return view('export_articles_sales', ['articoliVenduti' => $articoliVenduti]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting showArticlesSales: ' . $e->getMessage(), 500);

        }
    }
    public function showArticlesFatturati(Request $request)
    {
        try {

            $articoliVenduti = $this->queryArticlesFatturati();

            return view('export_articles_fatturati', ['articoliVenduti' => $articoliVenduti]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting showArticlesFatturati: ' . $e->getMessage() .
                'Articoli Fatturati ' . json_encode($articoliVenduti), 500);

        }
    }
    public function showArticoliByDataStart($data_start)
    {
        try {
            $this->validateDate($data_start);

            $articoliVenduti = $this->articoliByDataStart($data_start);

            if ($articoliVenduti && isset($articoliVenduti['error'])) {
                return view('error', ['message' => $articoliVenduti['error']]);
            }

            return view('view-lista-ordini-totale', ['articoli' => $articoliVenduti]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting showArticoliByDataStart: ' . $e->getMessage(), 500);


        }
    }
    protected function validateDate($date)
    {
        $validator = \Validator::make(['data_start' => $date], [
            'data_start' => 'required|date_format:Y-m-d'
        ]);

        if ($validator->fails()) {
            throw new ValidationException($validator);
        }
    }

    public function showOrdini($numrec)
    {
        try {

            $ordini = $this->queryOrdini($numrec);

            return view('ordini_test', ['ordini' => $ordini]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting showOrdini: ' . $e->getMessage(), 500);

        }
    }
    public function showOrdiniByIdArticolo($idArticolo)
    {
        try {

            $ordini = $this->queryOrdiniByIdArticolo($idArticolo);

            return view('ordini_test', ['ordini' => $ordini]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting showOrdiniByIdArticolo: ' . $e->getMessage(), 500);

        }
    }
    public function showFatturatiByIdArticolo($idArticolo)
    {
        try {

            $ordini = $this->queryFatturatiByIdArticolo($idArticolo);

            return view('fatturati', ['ordini' => $ordini]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting showFatturatiByIdArticolo: ' . $e->getMessage(), 500);

        }
    }
    public function showInfoArticolo($idArticolo)
    {
        try {

            $articoli = $this->queryshowInfoArticolo($idArticolo);

            if ($articoli && isset($articoli['error'])) {
                return view('error', ['message' => $articoli['error']]);
            }

            return view('info-articolo', ['articoli' => $articoli]);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting showInfoArticolo: ' . $e->getMessage(), 500);

        }
    }
    public function exportArticlesSales(Request $request): Response
    {
        try {

            $articoliVenduti = $this->queryArticlesSales();

            $filename = 'articoli_venduti_' . date('Y-m-d') . '.csv';
            $response = new Response();
            $response->headers->set('Content-Type', 'text/csv');
            $response->headers->set('Content-Disposition', 'attachment; filename="' . $filename . '"');


            $csvContent = "IdArticolo,Titolo,DataPubblicazione,Ean13,rank3M,rank6M,rank1Y,totVen,totVenUltimoMese,totVenUltimi6Mesi,totVenUltimoAnno,totVenUltimi2Anni,UltimoOrdine,misure\n";

            foreach ($articoliVenduti as $articoloVenduto) {
                $csvContent .= "{$articoloVenduto->idArticolo},{$articoloVenduto->Titolo},{$articoloVenduto->DataPubblicazione},{$articoloVenduto->rank3M},{$articoloVenduto->rank6M},{$articoloVenduto->rank1Y},{$articoloVenduto->totVen},{$articoloVenduto->venduti3mesi},{$articoloVenduto->venduti6mesi},{$articoloVenduto->venduti1anno},{$articoloVenduto->ultimoOrdine},{$articoloVenduto->misure}\n";
            }

            $response->setContent($csvContent);
            return $response;

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Error exporting exportArticlesSales: ' . $e->getMessage(), 500);
        }
    }

    public function exportArticlesSalesByJSON_Base($cosa, Request $request): Response
    {
        try {
            if ($cosa === 'fatturati') {
                $articoliVenduti = $this->queryArticlesFatturati();
            } else {
                $articoliVenduti = $this->queryArticlesSales();
            }

            if ($articoliVenduti->isEmpty()) {
                return response()->json(['message' => 'Nessun articolo trovato.'], 404);
            } else {

                // return response()->json($articoliVenduti);

                $result = $articoliVenduti->map(function ($articoloVenduto) {
                    return [
                        'IdArticolo' => $articoloVenduto->IdArticolo,
                        'title' => $articoloVenduto->Titolo,
                        'DataPubblicazione' => $articoloVenduto->DataPubblicazione,
                        'isbn' => $articoloVenduto->Ean13,
                        'IdCollana' => $articoloVenduto->IdCollana,
                        'DescrizioneCollana' => $articoloVenduto->DescrizioneCollana,
                        'DescrArgomento' => $articoloVenduto->DescrArgomento,
                        'ListaArgomenti' => $articoloVenduto->ListaArgomenti,
                        'Pagine' => $articoloVenduto->Pagine,
                        'IdTipoFormato' => $articoloVenduto->IdTipoFormato,
                        'Misure' => $articoloVenduto->Misure,
                        'totVen' => $articoloVenduto->totVen,
                        'totFat' => $articoloVenduto->totFat,
                        'rank3M' => $articoloVenduto->rank3M,
                        'fatrank3M' => $articoloVenduto->fatrank3M,
                        'fatrank6M' => $articoloVenduto->fatrank6M,
                        'rank6M' => $articoloVenduto->rank6M,
                        'rank1Y' => $articoloVenduto->rank1Y,
                        'fatLast3M' => $articoloVenduto->fat3mesi,
                        'fatLast6M' => $articoloVenduto->fat6mesi,
                        'vLast3M' => $articoloVenduto->venduti3mesi,
                        'vLast6M' => $articoloVenduto->venduti6mesi,
                        'vLastY' => $articoloVenduto->venduti1anno,
                        'dataUltimoOrdine' => $articoloVenduto->ultimoOrdine,
                    ];
                });

                // Imposta il contenuto della risposta come JSON
                $response = new Response($result->toJson(), 200);
                $response->headers->set('Content-Type', 'application/json');
                $response->headers->set('Content-Disposition', 'attachment; filename="ranking_' . $cosa . '_' . date('Y-m-d') . '.json"');

                return $response;
            }

        } catch (\Exception $e) {
            return new Response('Error exporting exportArticlesSalesByJSON_Base: ' . $e->getMessage() . '<br>Articoli: ' . json_decode($articoliVenduti), 500);
        }
    }

    public function exportArticlesSalesByJSON(Request $request): Response
    {
        return $this->exportArticlesSalesByJSON_Base('', $request);
    }

    public function exportArticlesFatturatiByJSON(Request $request): Response
    {
        return $this->exportArticlesSalesByJSON_Base('fatturati', $request);
    }

    public function test(Request $request)
    {
        try {

            $articoli = $this->queryTest2();

            dd($articoli);

        } catch (\Exception $e) {
            // Potresti considerare di registrare l'errore per debugging
            return new Response('Erroe test: ' . $e->getMessage(), 500);

        }
    }
    public function queryTest2()
    {
        try {
            $duplicati = DB::table('T_WEB_Articoli')
                ->select('idArticolo', 'Titolo', 'DataPubblicazione', 'Ean13', DB::raw('count(*) as total'))
                ->groupBy('idArticolo', 'Titolo', 'DataPubblicazione', 'Ean13')
                ->having('total', '>', 0) // Filtra duplicati
                ->get();


            return $duplicati;

        } catch (\Exception $e) {
            return new Response('Errore: ' . $e->getMessage(), 500);
        }

    }

    function showTableContent($tableName, $recordCount)
    {
        // Verifica se la tabella esiste
        if (!Schema::hasTable($tableName)) {
            return "La tabella '$tableName' non esiste.";
        }

        // Ottieni tutti i campi della tabella
        $columns = Schema::getColumnListing($tableName);

        // Recupera i record dalla tabella
        $records = DB::table($tableName)->take($recordCount)->get();

        // Se non ci sono record, restituisci un messaggio
        if ($records->isEmpty()) {
            return "Nessun record trovato nella tabella '$tableName'.";
        }

        // Prepara l'output in formato tabellare
        $output = "<table border='1'><thead><tr>";

        // Intestazioni della tabella
        foreach ($columns as $column) {
            $output .= "<th>$column</th>";
        }
        $output .= "</tr></thead><tbody>";

        // Righe dei dati
        foreach ($records as $record) {
            $output .= "<tr>";
            foreach ($columns as $column) {
                $output .= "<td>" . ($record->$column ?? 'NULL') . "</td>";
            }
            $output .= "</tr>";
        }

        $output .= "</tbody></table>";

        return $output;
    }


    public function showTableByName($tableName, $numrec)
    {

        // Usa la funzione showTableContent per ottenere i dati in formato tabellare
        $tableContent = $this->showTableContent($tableName, $numrec);

        // Passa i dati alla vista
        return view('article.info', [
            'tableName' => $tableName,
            'tableContent' => $tableContent
        ]);
    }
}
